/*

Grid builder
Helps you plan your space by defining simple grid to build upon.

Tomek Kozysa/ reborn / tomek@wearereborn.com

*/

var columns = 12;
var width = 60;
var gutters = 20;
var baseline = 20;

var components = {
	columns: { value: columns, label: 'Columns' },
	cwidth: { value: width, label: 'Width' },
	gutters: { value: gutters, label: 'Gutter size' },
	baseline: { value: baseline, label: 'Baseline' }
};

var values = Dialog.prompt('Define grid', components);




if (values) {
	
columns = values.columns;
width = values.cwidth;
gutters = values.gutters;
baseline = values.baseline;

}


var height = 1200;
var x = gutters;
var y = -baseline;

var components = [0, 0, 255, 0.5]; 
var columnColor = new RGBColor(components);

var groupC = new Group(); 
var groupG = new Group();
var groupI = new Group();


var grid = new Group();
for(var i = 0; i < columns; i++)
{
	
	
var bottomLeft = new Point(x, -1200);
var rectSize = new Size(width, height);
var myRect = new Path.Rectangle(bottomLeft, rectSize);
myRect.fillColor = columnColor;
myRect.strokeWidth = 0;
myRect.opacity = .2
x+=width+gutters;
	
	
	groupC.appendTop(myRect);
}



for (var i =0; i< height/baseline;i++)
{
	
var myPath = new Path();
myPath.add(new Point(0, y));
myPath.add(new Point(columns*width+gutters*columns+gutters, y));
y-=baseline;

myPath.strokeWidth = .25;
myPath.opacity = .2
myPath.strokeColor = '#ff0000'; 

groupG.appendTop(myPath);
}




for(var i = 0; i < columns+1; i++)
{
	if(i<columns){

			var bottomLeft = new Point(gutters+((width+gutters)*i), -10);
			var size = new Size(width, 20);
			var rectangle = new Rectangle(bottomLeft, size);
			var textItem = new AreaText(rectangle);

			textItem.characterStyle.fontSize = 9;
			textItem.characterStyle.fillColor = '#cccccc';
			textItem.paragraphStyle.justification = 'center';
			textItem.content = width+'';
			
			
			groupI.appendTop(textItem);
}

var bottomLeft = new Point(i*(gutters+width),-10);
var size = new Size(gutters, 20);
var rectangle = new Rectangle(bottomLeft, size);
var textItemG = new AreaText(rectangle);


textItemG.characterStyle.fontSize =9 ;
textItemG.characterStyle.fillColor = '#cccccc';
textItemG.paragraphStyle.justification = 'center';
textItemG.content = gutters+'';
groupI.appendTop(textItemG);

}

grid.appendTop(groupC);
grid.appendTop(groupG);
grid.appendTop(groupI);



var bottomLeft = new Point(0,5);
var size = new Size(gutters+(gutters*columns)+(columns*width), 20);
var rectangle = new Rectangle(bottomLeft, size);
var textItemG = new AreaText(rectangle);


textItemG.characterStyle.fontSize =12 ;
textItemG.characterStyle.fillColor = '#cccccc';
textItemG.paragraphStyle.justification = 'center';
textItemG.content = 'total width: '+size.width+'px';
groupI.appendTop(textItemG);



